/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.blocks.storage;

import net.minecraft.class_1799;
import net.minecraft.class_1922;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2371;
import net.minecraft.class_2586;
import net.minecraft.class_2680;
import reborncore.common.RebornCoreConfig;
import techreborn.client.EGui;
import techreborn.init.TRContent;
import techreborn.blockentity.storage.lesu.LapotronicSUBlockEntity;

public class BlockLapotronicSU extends BlockEnergyStorage {
	
	public BlockLapotronicSU() {
		super("LESU", EGui.LESU);
	}

	@Override
	public class_2586 method_10123(class_1922 worldIn) {
		return new LapotronicSUBlockEntity();
	}
	
	@Override
	public void getDrops(class_2680 state, class_2371<class_1799> drops, class_1937 world, class_2338 pos, int fortune) {
		if (RebornCoreConfig.wrenchRequired) {
			drops.add(new class_1799(TRContent.MachineBlocks.ADVANCED.getFrame()));
		} else {
			super.getDrops(state, drops, world, pos, fortune);
		}
	}
}
