/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.client.gui;

import com.mojang.blaze3d.platform.GlStateManager;
import net.minecraft.class_1074;
import net.minecraft.class_1657;
import net.minecraft.class_2585;
import net.minecraft.class_2960;
import net.minecraft.class_4185;
import net.minecraft.class_465;
import reborncore.client.gui.builder.widget.GuiButtonSimple;
import techreborn.blockentity.machine.tier3.ChunkLoaderBlockEntity;

public class GuiChunkLoader extends class_465 {

	private static final class_2960 texture = new class_2960("techreborn",
		"textures/gui/industrial_chunkloader.png");
	ChunkLoaderBlockEntity chunkloader;
	private class_4185 plusOneButton;
	private class_4185 plusTenButton;
	private class_4185 minusOneButton;
	private class_4185 minusTenButton;

	public GuiChunkLoader(int syncID, final class_1657 player, final ChunkLoaderBlockEntity chunkLoader) {
		super(chunkLoader.createContainer(syncID, player), player.field_7514, new class_2585("techreborn.chunkloader"));
		this.field_2792 = 176;
		this.field_2779 = 167;
		this.chunkloader = chunkLoader;
	}

	@Override
	public void init() {
		super.init();
		this.field_2776 = this.width / 2 - this.field_2792 / 2;
		this.field_2800 = this.height / 2 - this.field_2779 / 2;
		this.plusOneButton = new GuiButtonSimple(this.field_2776 + 5, this.field_2800 + 37, 40, 20, "+1", buttonWidget -> {});
		this.plusTenButton = new GuiButtonSimple(this.field_2776 + 45, this.field_2800 + 37, 40, 20, "+10", buttonWidget -> {});

		this.minusOneButton = new GuiButtonSimple(this.field_2776 + 90, this.field_2800 + 37, 40, 20, "-1", buttonWidget -> {});
		this.minusTenButton = new GuiButtonSimple(this.field_2776 + 130, this.field_2800 + 37, 40, 20, "-10", buttonWidget -> {});

		this.buttons.add(this.plusOneButton);
		this.buttons.add(this.plusTenButton);
		this.buttons.add(this.minusOneButton);
		this.buttons.add(this.minusTenButton);
	}

	@Override
	protected void method_2389(final float p_146976_1_, final int p_146976_2_, final int p_146976_3_) {
		this.renderBackground();
		GlStateManager.color4f(1.0F, 1.0F, 1.0F, 1.0F);
		minecraft.method_1531().method_4618(GuiChunkLoader.texture);
		final int k = (this.width - this.field_2792) / 2;
		final int l = (this.height - this.field_2779) / 2;
		this.blit(k, l, 0, 0, this.field_2792, this.field_2779);
	}

	@Override
	protected void method_2388(final int p_146979_1_, final int p_146979_2_) {
		final String name = class_1074.method_4662("blockEntity.techreborn:chunk_loader.name");
		this.font.method_1729(name, this.field_2792 / 2 - this.font.method_1727(name) / 2, 6,
			4210752);
		this.font.method_1729(class_1074.method_4662("container.inventory", new Object[0]), 8,
			this.field_2779 - 96 + 2, 4210752);
	}

	@Override
	public void render(int mouseX, int mouseY, float partialTicks) {
		super.render(mouseX, mouseY, partialTicks);
		this.method_2380(mouseX, mouseY);
	}

}
