package techreborn.client.render;

import io.github.prospector.silk.fluid.FluidInstance;
import net.fabricmc.fabric.api.client.render.fluid.v1.FluidRenderHandler;
import net.fabricmc.fabric.api.client.render.fluid.v1.FluidRenderHandlerRegistry;
import net.fabricmc.fabric.api.renderer.v1.Renderer;
import net.fabricmc.fabric.api.renderer.v1.RendererAccess;
import net.fabricmc.fabric.api.renderer.v1.material.RenderMaterial;
import net.fabricmc.fabric.api.renderer.v1.mesh.Mesh;
import net.fabricmc.fabric.api.renderer.v1.mesh.MeshBuilder;
import net.fabricmc.fabric.api.renderer.v1.mesh.MutableQuadView;
import net.fabricmc.fabric.api.renderer.v1.mesh.QuadEmitter;
import net.fabricmc.fabric.api.renderer.v1.model.FabricBakedModel;
import net.fabricmc.fabric.api.renderer.v1.render.RenderContext;
import net.minecraft.class_1058;
import net.minecraft.class_1087;
import net.minecraft.class_1309;
import net.minecraft.class_1799;
import net.minecraft.class_1920;
import net.minecraft.class_1937;
import net.minecraft.class_2338;
import net.minecraft.class_2350;
import net.minecraft.class_2680;
import net.minecraft.class_2960;
import net.minecraft.class_310;
import net.minecraft.class_3611;
import net.minecraft.class_3612;
import net.minecraft.class_777;
import net.minecraft.class_806;
import net.minecraft.class_809;
import reborncore.common.fluid.container.GenericFluidContainer;

import javax.annotation.Nullable;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.function.Supplier;

public class DynamicCellBakedModel implements class_1087, FabricBakedModel {

	class_1058 base;

	public DynamicCellBakedModel() {
		base = class_310.method_1551().method_1549().method_4608(new class_2960("techreborn:item/cell_base"));
	}

	@Override
	public void emitBlockQuads(class_1920 blockView, class_2680 state, class_2338 pos, Supplier<Random> randomSupplier, RenderContext context) {

	}

	@Override
	public void emitItemQuads(class_1799 stack, Supplier<Random> randomSupplier, RenderContext context) {
		GenericFluidContainer<class_1799> fluidContainer = GenericFluidContainer.fromStack(stack);
		class_3611 fluid = class_3612.field_15906;
		if(fluidContainer != null){
			FluidInstance fluidInstance = fluidContainer.getFluidInstance(stack);
			if(!fluidInstance.isEmpty()){
				fluid = fluidContainer.getFluidInstance(stack).getFluid();
			}
		}
		context.meshConsumer().accept(getMesh(fluid));
	}

	@Override
	public List<class_777> method_4707(@Nullable class_2680 blockState, @Nullable class_2350 direction, Random random) {
		return Collections.emptyList();
	}

	//I have no idea what im doing, this works good enough for me, if you want to make it nicer a PR or tips would be appreciated, thanks.
	private Mesh getMesh(class_3611 fluid){
		Renderer renderer = RendererAccess.INSTANCE.getRenderer();
		MeshBuilder builder = renderer.meshBuilder();
		QuadEmitter emitter = builder.getEmitter();

		RenderMaterial mat = renderer.materialFinder().disableDiffuse(0, true).find();

		//TODO make the base texture 3d somehow
		emitter.square(class_2350.field_11035, 0, 0, 1, 1, 0)
			.material(mat)
			.spriteColor(0, -1, -1, -1, -1)
			.spriteBake(0, base, MutableQuadView.BAKE_LOCK_UV).emit();

		if(fluid != class_3612.field_15906){
			FluidRenderHandler fluidRenderHandler = FluidRenderHandlerRegistry.INSTANCE.get(fluid);
			if(fluidRenderHandler != null){
				class_1058 fluidSprite = fluidRenderHandler.getFluidSprites(class_310.method_1551().field_1687, class_2338.field_10980, fluid.method_15785())[0];
				emitter.square(class_2350.field_11035, 0.4F, 0.25F, 0.6F, 0.75F, -0.0001F)
					.material(mat)
					.spriteColor(0, -1, -1, -1, -1)
					.spriteBake(0, fluidSprite, MutableQuadView.BAKE_LOCK_UV).emit();
			}
		}

		return builder.build();
	}


	@Override
	public boolean isVanillaAdapter() {
		return false;
	}

	@Override
	public boolean method_4708() {
		return true;
	}

	@Override
	public boolean method_4712() {
		return true;
	}

	@Override
	public boolean method_4713() {
		return false;
	}

	@Override
	public class_1058 method_4711() {
		return base;
	}

	@Override
	public class_809 method_4709() {
		return ModelHelper.HANDHELD_ITEM_TRANSFORMS;
	}

	protected class ItemProxy extends class_806 {
		public ItemProxy() {
			super(null, null, null, Collections.emptyList());
		}

		@Override
		public class_1087 method_3495(class_1087 bakedModel, class_1799 itemStack, class_1937 world, class_1309 livingEntity) {
			return DynamicCellBakedModel.this;
		}
	}

	@Override
	public class_806 method_4710() {
		return new ItemProxy();
	}
}
