/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.init.recipes;

import net.minecraft.class_1792;
import net.minecraft.class_1799;
import net.minecraft.class_1856;
import net.minecraft.class_2248;
import reborncore.common.util.StringUtils;

/**
 * Created by Prospector
 */
public abstract class RecipeMethods {
	public static class_1799 getMaterial(String name, int count, Type type) {
//		if (type == Type.DUST) {
//			return ItemDusts.getDustByName(name, count);
//		} else if (type == Type.SMALL_DUST) {
//			return ItemDustsSmall.getSmallDustByName(name, count);
//		} else if (type == Type.INGOT) {
//			return ItemIngots.getIngotByName(name, count);
//		} else if (type == Type.GEM) {
//			return ItemGems.getGemByName(name, count);
//			TODO: fix recipe
//		} else if (type == Type.PLATE) {
//			return ItemPlates.getPlateByName(name, count);
//		} else if (type == Type.NUGGET) {
//			return ItemNuggets.getNuggetByName(name, count);
//		} else 
//			if (type == Type.CELL) {
//			return ItemCells.getCellByName(name, count);
//		} else if (type == Type.PART) {
//			return ItemParts.getPartByName(name, count);
//		} else if (type == Type.CABLE) {
//			return BlockCable.getCableByName(name, count);
//		} else if (type == Type.MACHINE_FRAME) {
//			return BlockMachineFrames.getFrameByName(name, count);
//		} else if (type == Type.MACHINE_CASING) {
//			return BlockMachineCasing.getStackByName(name, count);
//		} else if (type == Type.UPGRADE) {
//			return ItemUpgrades.getUpgradeByName(name, count);
//		} else if (type == Type.ORE) {
//			return BlockOre.getOreByName(name, count);
//		}
		return class_1799.field_8037;
	}

	static Object getMaterialObjectFromType(String name, Type type) {
		Object object = null;
		if (type == Type.DUST) {
			object = "dust" + StringUtils.toFirstCapital(name);
		} else if (type == Type.SMALL_DUST) {
			object = "smallDust" + StringUtils.toFirstCapital(name);
		} else if (type == Type.INGOT) {
			object = "ingot" + StringUtils.toFirstCapital(name);
		} else if (type == Type.GEM) {
			object = "gem" + StringUtils.toFirstCapital(name);
		} else if (type == Type.PLATE) {
			object = "plate" + StringUtils.toFirstCapital(name);
		} else if (type == Type.NUGGET) {
			object = "nugget" + StringUtils.toFirstCapital(name);
		}else if (type == Type.ORE) {
			object = "ore" + StringUtils.toFirstCapital(name);
		}
		if (object != null) {
			if (object instanceof String) {
				throw new UnsupportedOperationException("Use tags");
			} else {
				return object;
			}
		}
		return getMaterial(name, type);
	}

	public static class_1799 getMaterial(String name, Type type) {
		return getMaterial(name, 1, type);
	}

	public static Object getMaterialObject(String name, Type type) {
		return getMaterialObjectFromType(name, type);
	}

	@Deprecated
	public static class_1799 getOre(String name, int count) {
		throw new UnsupportedOperationException("Use tags");
	}

	@Deprecated
	public static class_1799 getOre(String name) {
		throw new UnsupportedOperationException("Use tags");
	}

	@Deprecated
	public static boolean oresExist(String... names) {
		throw new UnsupportedOperationException("Use tags");
	}

	public static class_1799 getStack(class_1792 item) {
		return getStack(item, 1);
	}

	public static class_1799 getStack(class_1792 item, int count) {
		return new class_1799(item, count);
	}


	public static class_1799 getStack(class_1792 item, boolean wildcard) {
		return getStack(item, 1, wildcard);
	}

	@Deprecated
	public static class_1799 getStack(class_1792 item, int count, boolean wildcard) {
		throw new UnsupportedOperationException("Use tags");
	}

	public static class_1799 getStack(class_2248 block) {
		return getStack(block, 1);
	}

	public static class_1799 getStack(class_2248 block, int count) {
		return getStack(block, count);
	}

	public static class_1799 getStack(class_2248 block, boolean wildcard) {
		return getStack(block, 1, true);
	}

	public static class_1799 getStack(class_2248 block, int count, boolean wildcard) {
		throw new UnsupportedOperationException("Use tags");
	}


	public static class_1856 getCell(String name, int count){
		throw new UnsupportedOperationException("fix me");
		//return new IngredientCell(ItemCells.getCellByName(name, count));
	}

	public static class_1856 getCell(String name){
		return getCell(name, 1);
	}

	public enum Type {
		DUST, SMALL_DUST, INGOT, NUGGET, PLATE, GEM, CELL, PART, CABLE, MACHINE_FRAME, MACHINE_CASING, UPGRADE, ORE
	}
}
