/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.proxies;

import net.minecraft.class_124;
import net.minecraft.class_1799;
import net.minecraft.class_310;
import reborncore.api.blockentity.IUpgradeable;
import reborncore.client.gui.builder.GuiBase;
import reborncore.client.hud.StackInfoHUD;
import techreborn.init.TRContent;
import techreborn.items.ItemDynamicCell;
import techreborn.items.ItemFrequencyTransmitter;

public class ClientProxy extends CommonProxy {

	@Override
	public void preInit() {
		super.preInit();
		StackInfoHUD.registerElement(new ItemFrequencyTransmitter.StackInfoFreqTransmitter());
//		RenderingRegistry.registerEntityRenderingHandler(EntityNukePrimed.class, new RenderManagerNuke());
//		MinecraftForge.EVENT_BUS.register(new IconSupplier());
//		MinecraftForge.EVENT_BUS.register(ClientEventHandler.class);
	}

	@Override
	public void init() {
		super.init();
//		MinecraftForge.EVENT_BUS.register(new StackToolTipEvent());
//		MinecraftForge.EVENT_BUS.register(GuiSlotConfiguration.class);
//		MinecraftForge.EVENT_BUS.register(GuiFluidConfiguration.class);
		// TODO FIX ME
		//ClientRegistry.registerKeyBinding(KeyBindings.config);
//		StateMap rubberLeavesStateMap = new StateMap.Builder().ignore(BlockRubberLeaves.CHECK_DECAY, BlockRubberLeaves.DECAYABLE).build();
//		ModelLoader.setCustomStateMapper(TRContent.RUBBER_LEAVES, rubberLeavesStateMap);
		GuiBase.wrenchStack = new class_1799(TRContent.WRENCH);
		GuiBase.fluidCellProvider = ItemDynamicCell::getCellWithFluid;
	}


	@Override
	public String getUpgradeConfigText() {
		if (class_310.method_1551().field_1755 instanceof GuiBase) {
			GuiBase base = (GuiBase) class_310.method_1551().field_1755;
			if (base.blockEntity instanceof IUpgradeable) {
				if (((IUpgradeable) base.blockEntity).canBeUpgraded()) {
					return class_124.field_1076 + "Right click to configure";
				}
			}
		}
		return super.getUpgradeConfigText();
	}

//	public class RenderManagerNuke implements IRenderFactory<EntityNukePrimed> {
//
//		@Override
//		public EntityRenderer<? super EntityNukePrimed> createRenderFor(EntityRenderDispatcher manager) {
//			return new RenderNukePrimed(manager);
//		}
//	}

	@Override
	public boolean fancyGraphics() {
		return class_310.method_1551().field_1690.field_1833;
	}

}
