package techreborn.rei;

import me.shedaniel.rei.api.RecipeDisplay;
import net.minecraft.class_1799;
import net.minecraft.class_2960;
import reborncore.common.crafting.RebornIngredient;
import reborncore.common.crafting.RebornRecipe;

import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

public class MachineRecipeDisplay<R extends RebornRecipe> implements RecipeDisplay<R> {

	private final R recipe;
	private List<List<class_1799>> inputs;
	private List<class_1799> outputs;

	public MachineRecipeDisplay(R recipe) {
		this.recipe = recipe;
		this.inputs = recipe.getRebornIngredients().stream().map(RebornIngredient::getStacks).collect(Collectors.toList());
		this.outputs = recipe.getOutputs();
	}

	@Override
	public Optional<R> getRecipe() {
		return Optional.ofNullable(recipe);
	}

	@Override
	public List<List<class_1799>> getInput() {
		return inputs;
	}

	@Override
	public List<List<class_1799>> getRequiredItems() {
		return inputs;
	}

	@Override
	public List<class_1799> getOutput() {
		return outputs;
	}

	@Override
	public class_2960 getRecipeCategory() {
		return recipe.getRebornRecipeType().getName();
	}
}
